#include "sys.h"
#include "delay.h"
#include "usart.h" 
#include "led.h" 		 	 
#include "lcd.h" 
#include "key.h" 
#include "touch.h"  
//ALIENTEKӢSTM32F103 ʵ26
// ʵ 
//֧֣www.openedv.com
//ӿƼ޹˾  

//ĻϽʾ"RST"
void Load_Drow_Dialog(void)
{
		LCD_Clear(WHITE);	//   
		POINT_COLOR=BLUE;	//Ϊɫ 
		LCD_ShowString(lcddev.width-24,0,200,16,16,"RST");//ʾ
		POINT_COLOR=RED;	//ûɫ 
}
////////////////////////////////////////////////////////////////////////////////
//ݴרв
//ˮƽ
//x0,y0:
//len:߳
//color:ɫ
void gui_draw_hline(u16 x0,u16 y0,u16 len,u16 color)
{
	if(len==0)return;
	LCD_Fill(x0,y0,x0+len-1,y0,color);	
}
//ʵԲ
//x0,y0:
//r:뾶
//color:ɫ
void gui_fill_circle(u16 x0,u16 y0,u16 r,u16 color)
{											  
	u32 i;
	u32 imax = ((u32)r*707)/1000+1;
	u32 sqmax = (u32)r*(u32)r+(u32)r/2;
	u32 x=r;
	gui_draw_hline(x0-r,y0,2*r,color);
	for (i=1;i<=imax;i++) 
	{
		if ((i*i+x*x)>sqmax)// draw lines from outside  
		{
 			if (x>imax) 
			{
				gui_draw_hline (x0-i+1,y0+x,2*(i-1),color);
				gui_draw_hline (x0-i+1,y0-x,2*(i-1),color);
			}
			x--;
		}
		// draw lines from inside (center)  
		gui_draw_hline(x0-x,y0+i,2*x,color);
		gui_draw_hline(x0-x,y0-i,2*x,color);
	}
}  
//֮ľֵ 
//x1,x2ȡֵ
//ֵ|x1-x2|
u16 my_abs(u16 x1,u16 x2)
{			 
	if(x1>x2)return x1-x2;
	else return x2-x1;
}  
//һ
//(x1,y1),(x2,y2):ʼ
//sizeĴϸ̶
//colorɫ
void lcd_draw_bline(u16 x1, u16 y1, u16 x2, u16 y2,u8 size,u16 color)
{
	u16 t; 
	int xerr=0,yerr=0,delta_x,delta_y,distance; 
	int incx,incy,uRow,uCol; 
	if(x1<size|| x2<size||y1<size|| y2<size)return; 
	delta_x=x2-x1; // 
	delta_y=y2-y1; 
	uRow=x1; 
	uCol=y1; 
	if(delta_x>0)incx=1; //õ 
	else if(delta_x==0)incx=0;//ֱ 
	else {incx=-1;delta_x=-delta_x;} 
	if(delta_y>0)incy=1; 
	else if(delta_y==0)incy=0;//ˮƽ 
	else{incy=-1;delta_y=-delta_y;} 
	if( delta_x>delta_y)distance=delta_x; //ѡȡ 
	else distance=delta_y; 
	for(t=0;t<=distance+1;t++ )// 
	{  
		gui_fill_circle(uRow,uCol,size,color);// 
		xerr+=delta_x ; 
		yerr+=delta_y ; 
		if(xerr>distance) 
		{ 
			xerr-=distance; 
			uRow+=incx; 
		} 
		if(yerr>distance) 
		{ 
			yerr-=distance; 
			uCol+=incy; 
		} 
	}  
}   
////////////////////////////////////////////////////////////////////////////////
 //5صɫ												 
const u16 POINT_COLOR_TBL[CT_MAX_TOUCH]={RED,GREEN,BLUE,BROWN,GRED};  
//败Ժ
void rtp_test(void)
{
	u8 key;
	u8 i=0;	  
	while(1)
	{
	 	key=KEY_Scan(0);
		tp_dev.scan(0); 		 
		if(tp_dev.sta&TP_PRES_DOWN)			//
		{	
		 	if(tp_dev.x[0]<lcddev.width&&tp_dev.y[0]<lcddev.height)
			{	
				if(tp_dev.x[0]>(lcddev.width-24)&&tp_dev.y[0]<16)Load_Drow_Dialog();//
				else TP_Draw_Big_Point(tp_dev.x[0],tp_dev.y[0],RED);		//ͼ	  			   
			}
		}else delay_ms(10);	//ûаµʱ 	    
		if(key==KEY0_PRES)	//KEY0,ִУ׼
		{
			LCD_Clear(WHITE);//
		    TP_Adjust();  	//ĻУ׼  
			Load_Drow_Dialog();
		}
		i++;
		if(i%20==0)LED0=!LED0;
	}
}
//ݴԺ
void ctp_test(void)
{
	u8 t=0;
	u8 i=0;	  	    
 	u16 lastpos[5][2];		//¼һε 
	while(1)
	{
		tp_dev.scan(0);
		for(t=0;t<CT_MAX_TOUCH;t++)
		{
			if((tp_dev.sta)&(1<<t))
			{
				if(tp_dev.x[t]<lcddev.width&&tp_dev.y[t]<lcddev.height)
				{
					if(lastpos[t][0]==0XFFFF)
					{
						lastpos[t][0] = tp_dev.x[t];
						lastpos[t][1] = tp_dev.y[t];
					}
					lcd_draw_bline(lastpos[t][0],lastpos[t][1],tp_dev.x[t],tp_dev.y[t],2,POINT_COLOR_TBL[t]);//
					lastpos[t][0]=tp_dev.x[t];
					lastpos[t][1]=tp_dev.y[t];
					if(tp_dev.x[t]>(lcddev.width-24)&&tp_dev.y[t]<16)
					{
						Load_Drow_Dialog();//
					}
				}
			}else lastpos[t][0]=0XFFFF;
		}
		
		delay_ms(5);i++;
		if(i%20==0)LED0=!LED0;
	}	
}

int main(void)
{		 
 	Stm32_Clock_Init(9);	//ϵͳʱ
	uart_init(72,115200);	//ڳʼΪ115200
	delay_init(72);	   	 	//ʱʼ 
	LED_Init();		  		//ʼLEDӵӲӿ
	LCD_Init();			   	//ʼLCD
	KEY_Init();				//ʼ		 	
	tp_dev.init();			//ʼ	
	LCD_Clear(0xf800);//
	delay_ms(1500);
	LCD_Clear(0x07E0);//
	delay_ms(1500);
	LCD_Clear(0x001f);//
	delay_ms(1500);
	LCD_Clear(0x8410);//
	delay_ms(1500);
	LCD_Clear(0x0000);//
	delay_ms(1500);
	LCD_Clear(0xffff);//
	delay_ms(1500);
	display_HDBK(800,480,0x0000,0xFFFF);//ʾ߿
	delay_ms(1500);
	qipan_display(800,480,80,80);//ʾڰ̸
	delay_ms(1500);
	display_crosstalk(800,480,160,160);//ʾcrosstalk
	delay_ms(1500);
	display_colorbar_H( );//ʾˮƽɫ
	delay_ms(1500);
	display_colorbar_V( );//ʾֱɫ
	delay_ms(1500);
	display_gray_H( );//ʾˮƽҽ
	delay_ms(1500);
	display_gray_V( );//ʾֱҽ
	delay_ms(1500);
	LCD_Clear(0xffff);
	
 	POINT_COLOR=RED;//Ϊɫ 
	LCD_ShowString(30,50,200,16,16,"ELITE STM32F103 ^_^");	
	LCD_ShowString(30,70,200,16,16,"TOUCH TEST");	
	LCD_ShowString(30,90,200,16,16,"WKS70WV002");
	LCD_ShowString(30,110,200,16,16,"2016/12/26");
   	if((tp_dev.touchtype&0X80)==0X00)LCD_ShowString(30,130,200,16,16,"Press KEY0 to Adjust");//ʾ
	delay_ms(1500);
	Load_Drow_Dialog();	  
	if(tp_dev.touchtype&0X80)ctp_test();	//
	else rtp_test(); 						//
}























